Truy vấn kết quả hạch toán lệnh chi hộ
POST
URLhttps://open-api.tingee.vn/v1/direct-link/transaction-inquiry
Truy vấn trạng thái hạch toán giao dịch trong lệnh chi hộ Lô.
Header Request
| Header | Bắt buộc | Mô tả |
|---|---|---|
Content-Type | ✓ | application/json |
x-client-id | ✓ | Mã định danh của đối tác do TINGEE cung cấp. |
x-signature | ✓ | Chữ ký xác thực HMAC SHA512. |
x-request-timestamp | ✓ | Thời gian gửi request (format: yyyyMMddHHmmssSSS, múi giờ UTC+7) |
Body Parameter
| Trường | Kiểu | Bắt buộc | Mô tả |
|---|---|---|---|
bankBin | string | ✓ | Mã BIN ngân hàng (Truyền cố định 970415 - VietinBank). |
batchId | string | ✓ | Mã lô giao dịch (lấy từ response khi tạo lệnh chi lô). |
Ví dụ mã nguồn
- cURL
- NestJS
- C#
- Java
- PHP
curl --location --request POST 'https://open-api.tingee.vn/v1/direct-link/transaction-inquiry' \
--header 'accept: application/json' \
--header 'x-signature: YOUR_SIGNATURE' \
--header 'x-request-timestamp: 20251110175110111' \
--header 'x-client-id: YOUR_CLIENT_ID' \
--header 'Content-Type: application/json' \
--data '{
"bankBin": "970415",
"batchId": "7CB875795D6B2F3374D3B489B09CAA92"
}'
import axios from "axios";
import { createHmac } from "crypto";
import { format } from 'date-fns';
async function makeRequest() {
const timestamp = format(new Date(), "yyyyMMddHHmmssSSS");
const secretKey = "YOUR_SECRET_KEY";
const body = {
"bankBin": "970415",
"batchId": "7CB875795D6B2F3374D3B489B09CAA92"
};
const message = `${timestamp}:${JSON.stringify(body)}`;
const signature = createHmac('sha512', secretKey).update(message).digest('hex');
const res = await axios({
method: 'POST',
url: 'https://open-api.tingee.vn/v1/direct-link/transaction-inquiry',
data: body,
headers: {
"x-client-id": "YOUR_CLIENT_ID",
"x-request-timestamp": timestamp,
"x-signature": signature,
"Content-Type": "application/json",
}
});
console.log(res.data);
}
using System;
using System.Net.Http;
using System.Text;
using System.Security.Cryptography;
using System.Threading.Tasks;
public class TingeeApiExample
{
private static readonly HttpClient client = new HttpClient();
public static async Task Main()
{
var timestamp = DateTime.Now.ToString("yyyyMMddHHmmssfff");
var secretKey = "YOUR_SECRET_KEY";
var bodyJson = "{\"bankBin\":\"970415\",\"batchId\":\"7CB875795D6B2F3374D3B489B09CAA92\"}";
var message = $"{timestamp}:{bodyJson}";
var signature = CreateHmacSha512(secretKey, message);
var request = new HttpRequestMessage(HttpMethod.Post, "https://open-api.tingee.vn/v1/direct-link/transaction-inquiry");
request.Headers.Add("x-signature", signature);
request.Headers.Add("x-request-timestamp", timestamp);
request.Headers.Add("x-client-id", "YOUR_CLIENT_ID");
request.Content = new StringContent(bodyJson, Encoding.UTF8, "application/json");
var response = await client.SendAsync(request);
string result = await response.Content.ReadAsStringAsync();
Console.WriteLine(result);
}
private static string CreateHmacSha512(string key, string message)
{
using var hmac = new HMACSHA512(Encoding.UTF8.GetBytes(key));
var hash = hmac.ComputeHash(Encoding.UTF8.GetBytes(message));
return BitConverter.ToString(hash).Replace("-", "").ToLower();
}
}
import java.net.http.*;
import java.net.URI;
import java.nio.charset.StandardCharsets;
import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
public class TingeeApiExample {
public static void main(String[] args) throws Exception {
String secretKey = "YOUR_SECRET_KEY";
String timestamp = LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyyMMddHHmmssSSS"));
String bodyJson = "{\"bankBin\":\"970415\",\"batchId\":\"7CB875795D6B2F3374D3B489B09CAA92\"}";
String message = timestamp + ":" + bodyJson;
String signature = hmacSha512(secretKey, message);
HttpClient client = HttpClient.newHttpClient();
HttpRequest request = HttpRequest.newBuilder()
.uri(URI.create("https://open-api.tingee.vn/v1/direct-link/transaction-inquiry"))
.header("accept", "application/json")
.header("x-signature", signature)
.header("x-request-timestamp", timestamp)
.header("x-client-id", "YOUR_CLIENT_ID")
.header("Content-Type", "application/json")
.POST(HttpRequest.BodyPublishers.ofString(bodyJson))
.build();
HttpResponse<String> response = client.send(request, HttpResponse.BodyHandlers.ofString());
System.out.println(response.body());
}
private static String hmacSha512(String key, String data) throws Exception {
Mac mac = Mac.getInstance("HmacSHA512");
SecretKeySpec secretKeySpec = new SecretKeySpec(key.getBytes(StandardCharsets.UTF_8), "HmacSHA512");
mac.init(secretKeySpec);
byte[] hash = mac.doFinal(data.getBytes(StandardCharsets.UTF_8));
return toHex(hash);
}
private static String toHex(byte[] bytes) {
StringBuilder hex = new StringBuilder(bytes.length * 2);
for (byte b : bytes) {
hex.append(String.format("%02x", b));
}
return hex.toString();
}
}
function makeApiRequest() {
\$timestamp = date("YmdHis") . substr((string)microtime(true), -3);
\$secretKey = "YOUR_SECRET_KEY";
\$jsonBody = '{"bankBin":"970415","batchId":"7CB875795D6B2F3374D3B489B09CAA92"}';
\$message = \$timestamp . ":" . \$jsonBody;
\$signature = hash_hmac("sha512", \$message, \$secretKey);
\$ch = curl_init();
curl_setopt_array(\$ch, [
CURLOPT_URL => "https://open-api.tingee.vn/v1/direct-link/transaction-inquiry",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_POST => true,
CURLOPT_POSTFIELDS => \$jsonBody,
CURLOPT_HTTPHEADER => [
"Accept: application/json",
"Content-Type: application/json",
"x-client-id: YOUR_CLIENT_ID",
"x-request-timestamp: " . \$timestamp,
"x-signature: " . \$signature
]
]);
\$response = curl_exec(\$ch);
curl_close(\$ch);
echo \$response;
}
makeApiRequest();
Response mẫu
{
"code": "00",
"message": "Success",
"data": {
"totalRecords": 2,
"batchId": "7CB875795D6B2F3374D3B489B09CAA92",
"records": [
{
"requestId": "TRANS_0611_A01",
"status": "PENDING",
"statusDesc": "Giao dich Pending cho hach toan",
"transactionId": null,
"feeAmount": null,
"feeVAT": null
},
{
"requestId": "TRANS_0611_A02",
"status": "PENDING",
"statusDesc": "Giao dich Pending cho hach toan",
"transactionId": null,
"feeAmount": null,
"feeVAT": null
}
]
}
}
Cấu trúc Response data
| Trường | Kiểu | Mô tả |
|---|---|---|
totalRecords | number | Tổng số lượng bản ghi trong lô. |
batchId | string | Mã lô giao dịch. |
records | array | Danh sách thông tin chi tiết từng giao dịch. |
Chi tiết phần tử trong data.records
| Trường | Kiểu | Mô tả |
|---|---|---|
requestId | string | Mã tham chiếu giao dịch đã gửi lên. |
status | string | Trạng thái giao dịch. Có 3 trạng thái: SUCCESS, PENDING, FAILED. |
statusDesc | string | Thông báo diễn giải chi tiết cho trạng thái giao dịch. |
transactionId | string | Mã giao dịch trên hệ thống ngân hàng (có thể null nếu đang xử lý). |
feeAmount | number | Số tiền phí giao dịch. |
feeVAT | number | Số tiền thuế VAT của phí giao dịch. |
Mã lỗi thường gặp
| Code | Mô tả | Hướng xử lý |
|---|---|---|
90 | Sai format timestamp | Kiểm tra format yyyyMMddHHmmssSSS. |
91 | Request quá hạn | Kiểm tra thời gian gửi request. |
97 | Sai chữ ký | Kiểm tra lại Secret Key và logic tạo Signature. |
Others | Lỗi khác | Xem Danh sách mã lỗi. |